local AddonName, Hermes_Parrot = ...

local LIB_AceAddon = LibStub("AceAddon-3.0") or error("Required library AceAddon-3.0 not found")
local Hermes = LibStub("AceAddon-3.0"):GetAddon("Hermes")
_G[AddonName] = LIB_AceAddon:NewAddon(Hermes_Parrot, AddonName)
local ParrotDisplay = nil

function Hermes_Parrot:OnEnable()
	local Parrot = LIB_AceAddon:GetAddon("Parrot", true)
	if(Parrot) then
		ParrotDisplay = Parrot:GetModule("Display")
	end
end

function Hermes_Parrot:OnDisable()
	
end

function Hermes_Parrot:OnEnablePlugin()
	--wire up events
	Hermes:RegisterHermesEvent("OnAbilityInstanceStartCooldown", AddonName, function(instance) Hermes_Parrot:OnAbilityInstanceStartCooldown(instance) end)
	Hermes:RegisterHermesEvent("OnAbilityInstanceStopCooldown", AddonName, function(instance) Hermes_Parrot:OnAbilityInstanceStopCooldown(instance) end)
end

function Hermes_Parrot:OnDisablePlugin()
	Hermes:UnregisterHermesEvent("OnAbilityInstanceStartCooldown", AddonName)
	Hermes:UnregisterHermesEvent("OnAbilityInstanceStopCooldown", AddonName)
end

function Hermes_Parrot:OnInitialize()
	Hermes:RegisterHermesPlugin(
		AddonName,
		function() return self:OnEnablePlugin() end,
		function () return self:OnDisablePlugin() end,
		nil,
		nil
	)
end

function Hermes_Parrot:OnAbilityInstanceStartCooldown(instance)
	if instance.sender.name ~= UnitName("Player") then
		Hermes_Parrot:SendNotReadyMessage(instance.sender.name, instance.ability.name, instance.ability.icon, instance.sender.class)
	end
end

function Hermes_Parrot:OnAbilityInstanceStopCooldown(instance)
	if instance.sender.name ~= UnitName("Player") then
		Hermes_Parrot:SendReadyMessage(instance.sender.name, instance.ability.name, instance.ability.icon, instance.sender.class)
	end
end

function Hermes_Parrot:SendNotReadyMessage(sender, name, icon, class)
	if ParrotDisplay and ParrotDisplay:IsEnabled() then
		ParrotDisplay:ShowMessage("|c"..Hermes:GetClassColorHEX(class)..sender.."|r (|T"..icon..":0:0:0:0|t"..name..")",
			nil,			--scroll area, default is Notification
			false,			--sticky
			nil,			--r
			nil,			--g
			nil,			--b
			nil,			--font
			nil,			--fontSize
			nil,			--outline
			"Interface\\RAIDFRAME\\ReadyCheck-NotReady.blp"
		)
	end
end

function Hermes_Parrot:SendReadyMessage(sender, name, icon, class)
	if ParrotDisplay and ParrotDisplay:IsEnabled() then
		ParrotDisplay:ShowMessage("|c"..Hermes:GetClassColorHEX(class)..sender.."|r (|T"..icon..":0:0:0:0|t"..name..")",
			nil,			--scroll area, default is Notification
			false,			--sticky
			nil,			--r
			nil,			--g
			nil,			--b
			nil,			--font
			nil,			--fontSize
			nil,			--outline
			"Interface\\RAIDFRAME\\ReadyCheck-Ready.blp"
		)
	end
end
